﻿Type=Class
Version=7.01
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@

Sub Class_Globals

	Private sv As ScrollView
	Private items As List
	Private panels As List
	Private pressedDrawable As Object
	
	Private EventName As String
	Private CallBack As Object
	
	'for overflow menu
	Private EventName2 As String
	Private CallBack2 As Object
	
	Private su As StringUtils
	
	Private DefaultDividerHeight As Float
	
	Private DefaultTextSize, DefaultTextSize2 As Int
	Private DefaultTextColor, DefaultTextColor2 As Int
	
	Private DefaultTextMenuSize, DefaultTextMenuSize2 As Int
	Private DefaultTextMenuColor, DefaultTextMenuColor2 As Int
	
	Private DividerColor As Int
	
	Private DefaultTextBackgroundColor As Int
	Private DefaultTextBackgroundMenuColor As Int
	
	Private DefaultTextFontType, DefaultTextFont2Type As Typeface
	Private DefaultTextFontMenuType, DefaultTextFont2MenuType As Typeface
		
	Private DefaultBitmapSize As Int
	Private DefaultBitmapSizeMenu As Int
	
	'special use for my project
	Public Tag As String
	Public TagPath As String
		
	Private h1, h2 As Int			'used in conjunction with TempBitmapSize 
	
	Public blnAnimPlus As Boolean
	Public AnimDuration As String 	'1500 is default
	
	Private blnSVColor As Boolean
	
	Private DefaultOverFlowIconSize As Int
	
	Private blnDividerColorMargin As Boolean
	
End Sub

'Example - lstView.Initialize(Me, "lstView")
Public Sub Initialize (vCallback As Object, vEventName As String)
	sv.Initialize2(0, "sv")
		
	items.Initialize
	panels.Initialize
		
	EventName = vEventName
	CallBack = vCallback
	
	CallBack2 = vCallback
	EventName2 = vEventName & "_OverFlowMenu"
	
	Dim r As Reflector
    r.Target = r.GetContext
    r.Target = r.RunMethod("getResources")
	Dim idPressed As Int
   	idPressed = r.GetStaticField("android.R$drawable", "list_selector_background")
	pressedDrawable = r.RunMethod2("getDrawable", idPressed, "java.lang.int")
		
	sv.Color = 0xFFD9D7DE 'this sets the dividers color
	DividerColor = 0xFFD9D7DE 'this sets the dividers color
	
	DefaultTextColor = Colors.White
	DefaultTextColor2 = Colors.Gray
	
	DefaultTextMenuColor = Colors.Cyan
	DefaultTextMenuColor2 = Colors.LightGray
	
	DefaultTextBackgroundColor = Colors.White
	DefaultTextBackgroundMenuColor = Colors.DarkGray
	
	DefaultTextSize = 24
	DefaultTextSize2 = 20
	
	DefaultTextMenuSize = 24
	DefaultTextMenuSize2 = 20
	
	DefaultTextFontType = Typeface.DEFAULT
	DefaultTextFont2Type = Typeface.DEFAULT
	
	DefaultTextFontMenuType = Typeface.DEFAULT
	DefaultTextFont2MenuType = Typeface.DEFAULT
		
	DefaultBitmapSize = 45dip
	DefaultBitmapSizeMenu = 45dip
	
	DefaultOverFlowIconSize =  40dip
'	DefaultOverFlowIconColor = Colors.Cyan
'	DefaultOverFlowIconMenuColor = Colors.Cyan
	
	DefaultDividerHeight = 2dip
		
	AnimDuration = 1500
	
	blnSVColor = False
	
	blnDividerColorMargin = False
	
	h1 = ((DefaultBitmapSize + 5dip)/2): h2 = h1 + h1
	
End Sub

'Clears all items.
Public Sub Clear
	items.Clear
	panels.Clear
	sv.Panel.Height = 0
	
	sv.Color = DefaultTextBackgroundColor		'do this for substitution for background with no panels
	blnSVColor = True
	
	For i = sv.Panel.NumberOfViews - 1 To 0 Step -1
		sv.Panel.RemoveViewAt(i)
	Next
End Sub

'Returns a view object that holds the list.
Public Sub AsView As View
	Return sv
End Sub

'Returns the number of items.
Public Sub GetSize As Int
	If items.Size > 0 Then
		If items.Get(items.Size -1) <> "*Mask*" Then
			Return items.Size 
		Else
			Return items.Size -1
		End If
	Else
		Return 0
	End If
End Sub

'Returns the Panel stored at the specified index.
Public Sub GetPanel(Index As Int) As Panel
	Dim p As Panel
	p = panels.Get(Index) 'this is the parent panel
	Return p.GetView(0)
End Sub

'Returns the value stored at the specified index.
Public Sub GetValue(Index As Int) As Object
	Return items.Get(Index)
End Sub

'Removes the item at the specified index.
Public Sub RemoveAt(Index As Int)
	'mask bottom panel if required (does not work properly)
'	If sv.Panel.Height < sv.Height Then
'		InsertMaskPanel(items.Size, "*Mask*")
'	End If
	
	Dim removePanel, p As Panel
	removePanel = panels.Get(Index)
	
	For i = Index + 1 To items.Size - 1
		p = panels.Get(i)
		p.Tag = i - 1
		p.Top = p.Top - removePanel.Height - DefaultDividerHeight
	Next
	
	sv.Panel.Height = sv.Panel.Height - removePanel.Height - DefaultDividerHeight
	
	items.RemoveAt(Index)
	panels.RemoveAt(Index)
	removePanel.RemoveView
	
End Sub

'Text = adds the text in first line
'Text2 = adds the text in Second line
'Value: will be returned in the Click, LongClick and Overflow event
'ImageName: is part of Material Icons Library and will be set to the far left panel.  See website for more info with names. https://materialdesignicons.com/
'ImageColor: Example - Colors.Red (Use with ImageName = Some Icon Name)
'GravityLine1: is for aligning First Text line. Put 0 if not used
'GravityLine2: is for aligning Second Text line. Put 0 if not used
'blnMenu: If True it will use the Menu properities.  If False it will use the non Menu Properties
'blnOverflow:  If True it will add an Overflow Image at the far right at 40dip default.  Use "xxx_OverFlowMenu_ItemClick (Index As Int, Value As Object)". xxx is the eventname of the object
'OverFlowColor: Example - Colors.Black.  (Use with blnOverFlow = true)
'blnSelection: If True will show highligh.  False will not
'SelectionColor: Example - Colors.Blue.  If SelectionColor = "" will set to Android Default color (Use with blnSelection = true)
Public Sub AddTextItem(Text As String, Text2 As String, Value As Object, ImageName As String, ImageColor As String, GravityLine1 As Int, GravityLine2 As Int, blnMenu As Boolean, blnOverflow As Boolean, OverFlowColor As String, blnSelection As Boolean, SelectionColor As String)
	If items.Size > 0 Then 
		If items.Get(items.Size -1) = "*Mask*" Then
			RemoveAt(items.Size -1)		'remove mask panel
		End If
	End If
	InsertAtTextItem(items.Size, Text, Text2, Value, ImageName, ImageColor, GravityLine1, GravityLine2, blnMenu, blnOverflow, OverFlowColor, blnSelection, SelectionColor)
End Sub

'Updates a custom item at the specified index.
Public Sub UpdateTextItem(Index As Int, Text As String, Text2 As String, Value As Object, ImageName As String, ImageColor As String, GravityLine1 As Int, GravityLine2 As Int, blnMenu As Boolean, blnOverflow As Boolean, OverFlowColor As String, blnSelection As Boolean, SelectionColor As String)
	If items.Size > 0 Then 
		If items.Get(items.Size -1) = "*Mask*" Then
			RemoveAt(items.Size -1)		'remove mask panel
		End If
	End If
	InsertAtTextItem(Index, Text, Text2, Value, ImageName, ImageColor, GravityLine1, GravityLine2, blnMenu, blnOverflow, OverFlowColor, blnSelection, SelectionColor)

End Sub

'Inserts a text item at the specified index.
Public Sub InsertAtTextItem(Index As Int, Text As String, Text2 As String, Value As Object, ImageName As String, ImageColor As String, GravityLine1 As Int, GravityLine2 As Int, blnMenu As Boolean, blnOverflow As Boolean, OverFlowColor As String, blnSelection As Boolean, SelectionColor As String)
''	Gravity.NO_GRAVITY				= 0
''	Gravity.CENTER_HORIZONTAL		= 1
''	Gravity.LEFT					= 3
''	Gravity.RIGHT					= 5
''	Gravity.CENTER_VERTICAL			= 16
''	Gravity.CENTER					= 17
''	Gravity.TOP						= 48
''	Gravity.BOTTOM					= 80
''	Gravity.FILL					= 119
	
	If ImageColor = "" Then ImageColor = Colors.Black		'prevents errors.  if overflow is used without left image or not inputed with left image
	If OverFlowColor = "" Then OverFlowColor = Colors.Black
	Dim blnCenterText1Selected, blnCenterText2Selected As Boolean
	
	'This Center correction only requied with Images
	'Make adjustment with label1 or label2 if center is used. eliminates adding spaces
	Select Case GravityLine1
		Case 1, 17, 33, 49, 65, 81, 97: blnCenterText1Selected = True
	End Select

	'Make adjustment with label2 if center is used.  eliminates adding spaces
	Select Case GravityLine2
		Case 1, 17, 33, 49, 65, 81, 97: blnCenterText2Selected = True
	End Select
	
	Dim TempBitmapSize As Int
	
	If blnMenu = True Then
		TempBitmapSize = DefaultBitmapSizeMenu
	Else
		TempBitmapSize = DefaultBitmapSize
	End If
		
	'h1 = ((TempBitmapSize + 20dip)/2): h2 = h1 + h1		'DETERMINES THE HEIGHT OF LABEL1 AND LABEL2 BY IMAGE SIZE	
	h1 = ((TempBitmapSize + 5dip)/2): h2 = h1 + h1		'Old and not working well with android 6 with 14 text size.  Strange??	

	
	Dim pnl As Panel
	pnl.Initialize("")
	
	Dim lbl, lbl2 As Label
	lbl.Initialize("")
	lbl2.Initialize("")
	
	'If Menu icon name is incorrect it will catch it
	Try
		Dim mi2 As MaterialIconView
		mi2.Initialize("MaterialIcon")
			
		If ImageName <> "" Then
			If mi2.Iconlist.IndexOf(ImageName) = -1 Then ImageName = ""
		End If
	Catch
		ImageName = ""
	End Try
	
	'Add Image Material Icons
	If ImageName <> "" Then
		mi2.Icon = mi2.Iconlist.IndexOf(ImageName)
		
		'Menu or Non Menu Icon colors
		mi2.Color = ImageColor		
		
		mi2.SizeDp = TempBitmapSize
		mi2.SizePx = TempBitmapSize
		
		pnl.AddView(mi2, 5dip, 0, TempBitmapSize, TempBitmapSize)		'5dip padding

		'animates the icons			
		If blnAnimPlus = True Then
			mi2.Visible = False
			mi2.SetVisibleAnimated(AnimDuration, True)		
		End If
	
	End If

	lbl.Gravity = Bit.Or(Gravity.CENTER_VERTICAL, GravityLine1)
	lbl2.Gravity = Bit.Or(Gravity.CENTER_VERTICAL, GravityLine2)
	
	Dim sType As Int
	If Text <> "" And Text2 = "" Then sType = 1
	If Text = "" And Text2 <> "" Then sType = 2
	If Text <> "" And Text2 <> "" Then sType = 3
	
	
	'text1
	lbl.Text = Text
	If blnMenu = True Then
		lbl.TextSize = DefaultTextMenuSize
	Else
		lbl.TextSize = DefaultTextSize
	End If
	
	'menu and non menu text color	
	If blnMenu = True Then
		lbl.TextColor = DefaultTextMenuColor
	Else
		lbl.TextColor = DefaultTextColor
	End If
	
	'menu and non menu font type
	If blnMenu = True Then
		lbl.Typeface = DefaultTextFontMenuType
	Else
		lbl.Typeface = DefaultTextFontType
	End If
	
	'-----------------------------------------
	
	'text2
	lbl2.Text = Text2
	If blnMenu = True Then
		lbl2.TextSize = DefaultTextMenuSize2
	Else
		lbl2.TextSize = DefaultTextSize2
	End If
	
	'menu and non menu text color
	If blnMenu = True Then
		lbl2.TextColor = DefaultTextMenuColor2
	Else
		lbl2.TextColor = DefaultTextColor2
	End If
	
	'menu and non menu font type
	If blnMenu = True Then
		lbl2.Typeface = DefaultTextFont2MenuType
	Else
		lbl2.Typeface = DefaultTextFont2Type
	End If
	
	Dim minHeight, minHeight2 As Int
	
'////////////////////////////////////
'Overflow type display
'////////////////////////////////////
	If blnOverflow = True Then
		
		'overflow menu image
		Dim mi3 As MaterialIconView
		mi3.Initialize("MaterialIcon3")
		mi3.Icon = mi3.Iconlist.IndexOf("DOTS_VERTICAL") 'DOTS_VERTICAL
		mi3.Color = OverFlowColor		'its better to use this instead of the bottom.  each panel can have different color
		
		'used for tracking click		
		Dim OverFlowMenu As Panel
		OverFlowMenu.Initialize("OverFlowMenu")
		OverFlowMenu.Color = Colors.Transparent
		OverFlowMenu.Tag = Index
				
		'////////////////////////////////////			
		'WITH IMAGE
		'////////////////////////////////////
		If ImageName <> "" Then
			Select Case sType
				'FIRST LABEL
				Case 1
					If blnCenterText1Selected = True Then
						pnl.AddView(lbl, TempBitmapSize + 10dip, 0, (sv.Width - (TempBitmapSize + TempBitmapSize)) - 20dip, h1)				'TempBitmapSize or DefaultOverFlowIconSize each have 10dip padding
					Else
						pnl.AddView(lbl, TempBitmapSize + 10dip, 0, (sv.Width - (TempBitmapSize + DefaultOverFlowIconSize)) - 20dip, h1)	
					End If
				'SECOND LABEL
				Case 2
					If blnCenterText2Selected = True Then
						pnl.AddView(lbl2, TempBitmapSize + 10dip, 0, (sv.Width - (TempBitmapSize + TempBitmapSize)) - 20dip, h1)										
					Else
						pnl.AddView(lbl2, TempBitmapSize + 10dip, 0, (sv.Width - (TempBitmapSize + DefaultOverFlowIconSize)) - 20dip, h1)
					End If
				'BOTH LABELS
				Case 3
					If blnCenterText1Selected = True Then
						pnl.AddView(lbl, TempBitmapSize + 10dip, 0, (sv.Width - (TempBitmapSize + TempBitmapSize)) - 20dip, h1)
					Else
						pnl.AddView(lbl, TempBitmapSize + 10dip, 0, (sv.Width - (TempBitmapSize + DefaultOverFlowIconSize)) - 20dip, h1)
					End If
					minHeight = su.MeasureMultilineTextHeight(lbl, Text)	

					If blnCenterText2Selected = True Then
						pnl.AddView(lbl2, TempBitmapSize + 10dip, 0, (sv.Width - (TempBitmapSize + TempBitmapSize)) - 20dip, h1)	
					Else
						pnl.AddView(lbl2, TempBitmapSize + 10dip, minHeight, (sv.Width - (TempBitmapSize + DefaultOverFlowIconSize)) - 20dip, h1)
					End If
			End Select
			
			'add overflow menu icon
			If blnCenterText1Selected = True Or blnCenterText2Selected = True Then
				pnl.AddView(mi3, sv.Width - DefaultOverFlowIconSize - 5dip, 0, DefaultOverFlowIconSize, DefaultOverFlowIconSize)
				pnl.AddView(OverFlowMenu, sv.Width - DefaultOverFlowIconSize - 5dip, 0, DefaultOverFlowIconSize + 20dip, DefaultOverFlowIconSize)				'+20dip is to extend click all the way to right	
			Else
				'fixes errors with one of the text box are empty
				If Text <> "" Then
					pnl.AddView(mi3, TempBitmapSize + 15dip + lbl.width, 0, DefaultOverFlowIconSize, DefaultOverFlowIconSize)
					pnl.AddView(OverFlowMenu, TempBitmapSize + 15dip + lbl.Width, 0, DefaultOverFlowIconSize + 20dip, DefaultOverFlowIconSize)						'+20dip is to extend click all the way to right	
				Else
					pnl.AddView(mi3, TempBitmapSize + 15dip + lbl2.Width, 0, DefaultOverFlowIconSize, DefaultOverFlowIconSize)
					pnl.AddView(OverFlowMenu, TempBitmapSize + 15dip + lbl2.Width, 0, DefaultOverFlowIconSize + 20dip, DefaultOverFlowIconSize)						'+20dip is to extend click all the way to right						
				End If
			End If
'			mi3.BringToFront
'			OverFlowMenu.BringToFront
			'animates the overflow			
			If blnAnimPlus = True Then
				mi3.Visible = False	
				mi3.SetVisibleAnimated(AnimDuration, True)		
			End If	
				
		'////////////////////////////////////	
		'WITHOUT IMAGE
		'////////////////////////////////////
		Else
			Select Case sType
				Case 1
					If blnCenterText1Selected = True Then
						pnl.AddView(lbl, 5dip + DefaultOverFlowIconSize + 5dip, 0, (sv.Width - (DefaultOverFlowIconSize * 2)) - 10dip - 10dip, h1)
					Else
						pnl.AddView(lbl, 5dip, 0, sv.Width - 5dip - DefaultOverFlowIconSize - 10dip, h1)	
					End If
				Case 2
					If blnCenterText2Selected = True Then
						pnl.AddView(lbl2, 5dip + DefaultOverFlowIconSize + 5dip, 0, (sv.Width - (DefaultOverFlowIconSize * 2)) - 10dip - 10dip, h1)
					Else
						pnl.AddView(lbl2, 5dip, 0, sv.Width - 5dip - DefaultOverFlowIconSize - 10dip, h1)
					End If	
				Case 3
					If blnCenterText1Selected = True Then
						pnl.AddView(lbl, 5dip + DefaultOverFlowIconSize + 5dip, 0, (sv.Width - (DefaultOverFlowIconSize * 2)) - 10dip - 10dip, h1)
					Else
						pnl.AddView(lbl, 5dip, 0, sv.Width - 5dip - DefaultOverFlowIconSize - 10dip, h1)	
					End If
					minHeight = su.MeasureMultilineTextHeight(lbl, Text)	

					If blnCenterText2Selected = True Then
						pnl.AddView(lbl2, 5dip + DefaultOverFlowIconSize + 5dip, 0, (sv.Width - (DefaultOverFlowIconSize * 2)) - 10dip - 10dip, h1)
					Else
						pnl.AddView(lbl2, 5dip, minHeight, sv.Width - 5dip - DefaultOverFlowIconSize - 10dip, h1)
					End If	
			End Select
			
			'add overflow menu icon
			If blnCenterText1Selected = True Or blnCenterText2Selected = True Then
				pnl.AddView(mi3, 5dip + DefaultOverFlowIconSize + 5dip + lbl.Width + 5dip, 0, DefaultOverFlowIconSize, DefaultOverFlowIconSize)
				pnl.AddView(OverFlowMenu, 5dip + DefaultOverFlowIconSize + 5dip + lbl.Width + 5dip, 0, DefaultOverFlowIconSize + 20dip, DefaultOverFlowIconSize)	'+20dip is to extend click all the way to right			
			Else
				pnl.AddView(mi3, 5dip + lbl.Width + 5dip, 0, DefaultOverFlowIconSize, DefaultOverFlowIconSize)
				pnl.AddView(OverFlowMenu, 5dip + lbl.Width + 5dip, 0, DefaultOverFlowIconSize + 20dip, DefaultOverFlowIconSize)										'+20dip is to extend click all the way to right	
			End If
'			mi3.BringToFront
'			OverFlowMenu.BringToFront
			'animates the overflow			
			If blnAnimPlus = True Then
				mi3.Visible = False	
				mi3.SetVisibleAnimated(AnimDuration, True)		
			End If	
			
		End If	
'////////////////////////////////////
'non overflow type
'////////////////////////////////////	
	Else
		'////////////////////////////////////
		'WITH IMAGE
		'////////////////////////////////////
		If ImageName <> "" Then
			Select Case sType
				'FIRST LABEL
				Case 1
					'If Center
					If blnCenterText1Selected = True Then
						pnl.AddView(lbl, TempBitmapSize + 10dip, 0, sv.Width - (TempBitmapSize * 2) - 10dip - 10dip, h1)
					Else
						pnl.AddView(lbl, TempBitmapSize + 10dip, 0, sv.Width - TempBitmapSize - 15dip, h1)	
					End If
				'SECOND LABEL
				Case 2
					If blnCenterText2Selected = True Then
						pnl.AddView(lbl2, TempBitmapSize + 10dip, 0, sv.Width - (TempBitmapSize * 2) - 10dip - 10dip, h1)
					Else
						pnl.AddView(lbl2, TempBitmapSize + 10dip, 0, sv.Width - TempBitmapSize - 15dip, h1)
					End If
				'BOTH LABELS
				Case 3
					If blnCenterText1Selected = True Then
						pnl.AddView(lbl, TempBitmapSize + 10dip, 0, sv.Width - (TempBitmapSize * 2) - 10dip - 10dip, h1)
					Else
						pnl.AddView(lbl, TempBitmapSize + 10dip, 0, sv.Width - TempBitmapSize - 15dip, h1)
					End If
					minHeight = su.MeasureMultilineTextHeight(lbl, Text)	

					If blnCenterText2Selected = True Then
						pnl.AddView(lbl2, TempBitmapSize + 10dip, 0, sv.Width - (TempBitmapSize * 2) - 10dip - 10dip, h1)
					Else
						pnl.AddView(lbl2, TempBitmapSize + 10dip, minHeight, sv.Width - TempBitmapSize - 15dip, h1)
					End If
			End Select
		'////////////////////////////////////
		'WITHOUT IMAGE
		'////////////////////////////////////
		Else
			Select Case sType
				Case 1
					pnl.AddView(lbl, 5dip, 0, sv.Width - 10dip, h1)	
				Case 2
					pnl.AddView(lbl2, 5dip, 0, sv.Width - 10dip, h1)
				Case 3
					pnl.AddView(lbl, 5dip, 0, sv.Width - 10dip, h1)
					minHeight = su.MeasureMultilineTextHeight(lbl, Text)	

					pnl.AddView(lbl2, 5dip, minHeight, sv.Width - 10dip, h1)
			End Select
		End If
		
	End If
	
	'set background color for menu or non menu type
	If blnMenu = True Then
		pnl.Color = DefaultTextBackgroundMenuColor
	Else
		pnl.Color = DefaultTextBackgroundColor
	End If
	
	'set the color to divider choice.  if there is no panels it will set as background choice.
	If blnSVColor = True Then
		blnSVColor = False
	
		If blnDividerColorMargin = False Then
			sv.Color = DividerColor
		End If
	End If
	
	'GET HEIGHT OF THE LABEL
	If Text <> "" Then 
		minHeight = su.MeasureMultilineTextHeight(lbl, Text)
	End If
	
	If Text2 <> "" Then
		minHeight2 = su.MeasureMultilineTextHeight(lbl2, Text2)
	End If
	
	'GET HIGHEST HEIGHT.  H2 IS PREDEFINED ABOVE IN GLOBALS
	Select Case sType
		Case 1
			lbl.Height = Max(h2, minHeight)	'with image
			lbl.Top = 3dip
		Case 2
			lbl2.Height = Max(h2, minHeight2)
			lbl2.Top = 3dip
		Case 3:
			lbl.Height = Max(h1, minHeight)
			lbl2.Height = Max(h1, minHeight2)
			lbl.Top = 3dip
			lbl2.Top = lbl.Top + lbl.Height			'SET RIGHT BELOW THE LABEL 1
	End Select
	
	'Images on left.  set the top preperty to center vertically
	If ImageName <> "" Then 
		Select Case sType
			Case 1: mi2.Top = ((lbl.Height - mi2.Height) + 6dip) /2
			Case 2: mi2.Top = ((lbl2.Height - mi2.Height) + 6dip) /2
			Case 3: mi2.Top = ((lbl.Height + lbl2.Height) - mi2.Height + 6dip) /2
		End Select		
	End If
	
	'Overflow menu icon.  set the top property to center vertically.  overflow will be all the height
	If blnOverflow = True Then
		Select Case sType
			Case 1
				mi3.Top = ((lbl.Height - mi3.Height) + 6dip) /2			'adjust overflow menu centered vertically
				OverFlowMenu.Height = lbl.Height						'overflow panel height all of the labels height.  so it gets a good coverage of click
				OverFlowMenu.Top = 0
				mi3.BringToFront
				OverFlowMenu.BringToFront
			Case 2
				mi3.Top = ((lbl2.Height - mi3.Height) + 6dip) /2
				OverFlowMenu.Height = lbl2.Height
				OverFlowMenu.Top = 0
				mi3.BringToFront
				OverFlowMenu.BringToFront
			Case 3
				mi3.Top = ((lbl.Height + lbl2.Height) - mi3.Height + 6dip) /2
				OverFlowMenu.Height = lbl.Height + lbl2.Height
				OverFlowMenu.Top = 0
				mi3.BringToFront
				OverFlowMenu.BringToFront
		End Select
	End If
	
	Select Case sType 
		Case 1:	InsertAt(Index, pnl, lbl.Height + 6dip, 0, Value, blnMenu, blnSelection, SelectionColor)
		Case 2: InsertAt(Index, pnl, 0, lbl2.Height + 6dip, Value, blnMenu, blnSelection, SelectionColor)
		Case 3: InsertAt(Index, pnl, lbl.Height, lbl2.Height + 6dip, Value, blnMenu, blnSelection, SelectionColor)
	End Select

End Sub

'Adds a custom item at the specified index.
Public Sub InsertAt(Index As Int, Pnl As Panel, ItemHeight As Int, ItemHeight2 As Int, Value As Object, blnMenu As Boolean, blnSelection As Boolean, SelectionColor As String)
    
	'add click pressed for selection type
	If blnSelection = True Then
		Dim sd As StateListDrawable
	    sd.Initialize
		
		'User color 
		If SelectionColor = "" Then
			sd.AddState(sd.State_Pressed, pressedDrawable)
		Else
			Dim cdColor As ColorDrawable
			cdColor.Initialize(SelectionColor, 0)
			sd.AddState(sd.State_Pressed, cdColor)				
		End If
				
	    sd.AddCatchAllState(Pnl.Background)			
	End If
		
	'create another panel to handle the click event
	Dim p As Panel

	Dim cd As ColorDrawable
	'highlight type
	If blnSelection = True Then		
		p.Initialize("panel")	'click sound and event
		p.Background = sd
		cd.Initialize(Colors.Transparent, 0)
	'no highlight
	Else
		p.Initialize("")		'no click sound
		If blnMenu = True Then
			cd.Initialize(DefaultTextBackgroundMenuColor, 0)
		Else
			cd.Initialize(DefaultTextBackgroundColor, 0)
		End If
	End If

	Pnl.Background = cd		
	
	'ripple effect
	If blnSelection = True Then
		Dim AC As AppCompat
		AC.SetClickEffect(Pnl, False)	
	End If
	
	p.AddView(Pnl, 0, 0, sv.Width, ItemHeight + ItemHeight2)
	p.Tag = Index
		
	If blnMenu = True Then
		If blnDividerColorMargin = True Then
			p.Elevation = 0
		Else
			p.Elevation = 25
		End If
	End If
	
	'LAST PANEL
	If Index = items.Size Then
		items.Add(Value)
		panels.Add(p)
		Dim Top As Int
		
		If Index = 0 Then 
			Top = DefaultDividerHeight 
		Else 
			Top = sv.Panel.Height
		End If
		
		sv.Panel.AddView(p, 0, Top, sv.Width, ItemHeight + ItemHeight2)
	'ANY PANELS BEFORE LAST
	Else
		Dim Top As Int
		If Index = 0 Then
			Top = DefaultDividerHeight
		Else
			Dim previousPanel As Panel
			previousPanel = panels.Get(Index - 1)
			Top = previousPanel.Top + previousPanel.Height + DefaultDividerHeight
		End If

		Dim p2 As Panel
		For i = Index To panels.Size - 1
			p2 = panels.Get(i)
			p2.Top = p2.Top + ItemHeight + ItemHeight2 + DefaultDividerHeight
			p2.Tag = i + 1
		Next
		items.InsertAt(Index, Value)
		panels.InsertAt(Index, p)
		sv.Panel.AddView(p, 0, Top, sv.Width, ItemHeight + ItemHeight2)
	End If
	
	sv.Panel.Height = sv.Panel.Height + ItemHeight + ItemHeight2 + DefaultDividerHeight
	If items.Size = 1 Then sv.Panel.Height = sv.Panel.Height + DefaultDividerHeight
	
	If sv.Panel.Height < sv.Height Then
		InsertMaskPanel(items.Size, "*Mask*")
	End If
		
End Sub

Private Sub InsertMaskPanel(Index As Int, Value As Object)
	Dim pnl As Panel
	pnl.Initialize("")
	
	Dim lbl As Label
	lbl.Initialize("")

	lbl.Gravity = Bit.Or(Gravity.CENTER_VERTICAL, Gravity.LEFT)
	
	'Dim minHeight As Int

	pnl.AddView(lbl, 5dip, sv.Panel.Height + DefaultDividerHeight, sv.Width - 5dip, h1)	
	
	pnl.Color = DefaultTextBackgroundColor
	
	If sv.Panel.Height > sv.Height Then
		lbl.Height = 1		'TEST THIS
	Else
		lbl.Height = sv.Height - sv.Panel.Height - DefaultDividerHeight
	End If
		
	InsertAtMask(Index, pnl, lbl.Height, Value)
End Sub

'Adds a mask panel at the last index.
Private Sub InsertAtMask(Index As Int, Pnl As Panel, ItemHeight As Int, Value As Object)
    
'	Dim sd As StateListDrawable
'    sd.Initialize
'    sd.AddState(sd.State_Pressed, pressedDrawable)
'    sd.AddCatchAllState(Pnl.Background)
	
	'create another panel to handle the click event
	Dim p As Panel
	'p.Initialize("panel")	'changing this to other than panel will remove click event and sound
	p.Initialize("")
	'p.Background = sd
	
	Dim cd As ColorDrawable
	cd.Initialize(DefaultTextBackgroundColor, 0)
    Pnl.Background = cd
	
	p.AddView(Pnl, 0, 0, sv.Width, ItemHeight)
	p.Tag = Index
	
	'LAST PANEL
	If Index = items.Size Then
		items.Add(Value)
		panels.Add(p)
		Dim Top As Int
		
		If Index = 0 Then 
			Top = DefaultDividerHeight 		'FIRST PANEL 
		Else 
			Top = sv.Panel.Height 		'AFTER FIRST PANEL
		End If
		
		sv.Panel.AddView(p, 0, Top, sv.Width, ItemHeight)			'ADD TO SV PANEL
	'ANY PANEL BEFORE LAST.  REMOVE THIS SINCE THIS IS MASK AND LAST PANEL????
	Else
		Dim Top As Int
		If Index = 0 Then
			Top = DefaultDividerHeight
		Else
			Dim previousPanel As Panel
			previousPanel = panels.Get(Index - 1)
			Top = previousPanel.Top + previousPanel.Height + DefaultDividerHeight
		End If

		Dim p2 As Panel
		For i = Index To panels.Size - 1
			p2 = panels.Get(i)
			p2.Top = p2.Top + ItemHeight + DefaultDividerHeight
			p2.Tag = i + 1
		Next
		items.InsertAt(Index, Value)
		panels.InsertAt(Index, p)
		sv.Panel.AddView(p, 0, Top, sv.Width, ItemHeight)
	End If
	
	sv.Panel.Height = sv.Panel.Height + ItemHeight + DefaultDividerHeight				
	If items.Size = 1 Then sv.Panel.Height = sv.Panel.Height + DefaultDividerHeight
	
End Sub

'Adds a custom item.
Public Sub Add(Pnl As Panel, ItemHeight As Int,  ItemHeight2 As Int, Value As Object, blnMenu As Boolean, blnSelection As Boolean, SelectionColor As String)
	InsertAt(items.Size, Pnl, ItemHeight, ItemHeight2, Value, blnMenu, blnSelection, SelectionColor)
End Sub

'Scrolls the list to the specified item.
Public Sub JumpToItem(Index As Int)
	Dim Top As Int
	Dim p As Panel
	For i = 0 To Min(Index - 1, items.Size - 1)
		p = panels.Get(i)
		Top = Top + p.Height + DefaultDividerHeight
	Next
	sv.ScrollPosition = Top
	'The scroll position doesn't always gets updated without two calls to DoEvents
	DoEvents
	sv.ScrollPosition = Top
	DoEvents
End Sub

Private Sub Panel_Click 
	If SubExists(CallBack, EventName & "_ItemClick") Then
		Dim v As View
		v = Sender
		CallSub3(CallBack, EventName & "_ItemClick", v.Tag, items.Get(v.Tag))
	End If
End Sub
Private Sub Panel_LongClick
	If SubExists(CallBack, EventName & "_LongClick") Then
		Dim v As View
		v = Sender
		CallSub3(CallBack, EventName & "_LongClick", v.Tag, items.Get(v.Tag))
	End If
End Sub
Private Sub OverflowMenu_Click 
	
	If SubExists(CallBack2, EventName2 & "_ItemClick") Then
		Dim v As View
		v = Sender
		CallSub3(CallBack2, EventName2 & "_ItemClick", v.Tag, items.Get(v.Tag))
	End If
	
End Sub

'Returns the index of the item that holds the given view.
Public Sub GetItemFromView(v As View) As String
	Dim r As Reflector
	Dim parent, current As Object
	parent = v
	Do While (parent Is Panel) = False Or sv.Panel <> parent
		current = parent
		r.Target = current
		parent = r.RunMethod("getParent")
	Loop
	v = current
	Return v.Tag
End Sub

'First line font size
Public Sub SetTextFontSize(Size As Int)
	DefaultTextSize = Size
End Sub
'Second line font size
Public Sub SetText2FontSize(Size As Int)
	DefaultTextSize2 = Size
End Sub

'First Line font Menu Size
Public Sub SetTextFontMenuSize(Size As Int)
	DefaultTextMenuSize = Size
End Sub
'Second line font Menu size
Public Sub SetText2FontMenuSize(Size As Int)
	DefaultTextMenuSize2 = Size
End Sub

'First line font color
Public Sub SetTextFontColor(Color As Int)
	DefaultTextColor = Color
End Sub
'Second line font color
Public Sub SetText2FontColor(Color As Int)
	DefaultTextColor2 = Color
End Sub

'First line font mnenu color
Public Sub SetTextFontMenuColor(Color As Int)
	DefaultTextMenuColor = Color
End Sub
'Second line font menu color
Public Sub SetText2FontMenuColor(Color As Int)
	DefaultTextMenuColor2 = Color
End Sub

'Text background color
Public Sub SetTextBackgroundColor(Color As Int)
	DefaultTextBackgroundColor = Color
End Sub
'Text background menu color
Public Sub SetTextBackgroundMenuColor(Color As Int)
	DefaultTextBackgroundMenuColor = Color
End Sub

'Divider color
Public Sub SetDividerColor(Color As Int)
'	sv.Color = Color
'	DividerColor = Color

	If GetSize = 0 Then
		blnSVColor = True
		sv.Color = DefaultTextBackgroundColor		'do this for substitution for background with no panels
		DividerColor = Color
	Else
		blnSVColor = False
		sv.Color = Color
		DividerColor = Color		
	End If
End Sub

'First Line Font Type
Public Sub SetTextFont(FontType As Typeface)
	DefaultTextFontType = FontType
End Sub
'Second Line Font Type
Public Sub SetText2Font(FontType As Typeface)
	DefaultTextFont2Type = FontType
End Sub

'First Line Font Menu Type
Public Sub SetTextMenuFont(FontType As Typeface)
	DefaultTextFontMenuType = FontType
End Sub
'Second Line Font Menu Type
Public Sub SetText2MenuFont(FontType As Typeface)
	DefaultTextFont2MenuType = FontType
End Sub

'Divider height (0 to 40) dip
Public Sub SetDividerHeight(Val As Int)
	Select Case Val
		Case 0: DefaultDividerHeight = 0dip
		Case 1: DefaultDividerHeight = 1dip
		Case 2: DefaultDividerHeight = 2dip
		Case 3: DefaultDividerHeight = 3dip
		Case 4: DefaultDividerHeight = 4dip
		Case 5: DefaultDividerHeight = 5dip
		Case 6: DefaultDividerHeight = 6dip
		Case 7: DefaultDividerHeight = 7dip
		Case 8: DefaultDividerHeight = 8dip
		Case 9: DefaultDividerHeight = 9dip
		Case 10: DefaultDividerHeight = 10dip
		Case 11: DefaultDividerHeight = 11dip
		Case 12: DefaultDividerHeight = 12dip
		Case 13: DefaultDividerHeight = 13dip
		Case 14: DefaultDividerHeight = 14dip
		Case 15: DefaultDividerHeight = 15dip
		Case 16: DefaultDividerHeight = 16dip
		Case 17: DefaultDividerHeight = 17dip
		Case 18: DefaultDividerHeight = 18dip
		Case 19: DefaultDividerHeight = 19dip
		Case 20: DefaultDividerHeight = 20dip
		Case 21: DefaultDividerHeight = 21dip
		Case 22: DefaultDividerHeight = 22dip
		Case 23: DefaultDividerHeight = 23dip
		Case 24: DefaultDividerHeight = 24dip
		Case 25: DefaultDividerHeight = 25dip
		Case 26: DefaultDividerHeight = 26dip
		Case 27: DefaultDividerHeight = 27dip
		Case 28: DefaultDividerHeight = 28dip
		Case 29: DefaultDividerHeight = 29dip
		Case 30: DefaultDividerHeight = 30dip
		Case 31: DefaultDividerHeight = 31dip
		Case 32: DefaultDividerHeight = 32dip
		Case 33: DefaultDividerHeight = 33dip
		Case 34: DefaultDividerHeight = 34dip
		Case 35: DefaultDividerHeight = 35dip
		Case 36: DefaultDividerHeight = 36dip
		Case 37: DefaultDividerHeight = 37dip
		Case 38: DefaultDividerHeight = 38dip
		Case 39: DefaultDividerHeight = 39dip
		Case 40: DefaultDividerHeight = 40dip
	
	End Select
End Sub

'Icon Size (25 to 150) dip
Public Sub SetIconSize(Val As Int)
	Select Case Val
		
		Case 25: DefaultBitmapSize = 25dip
		Case 30: DefaultBitmapSize = 30dip
		Case 35: DefaultBitmapSize = 35dip
		Case 40: DefaultBitmapSize = 40dip
		Case 45: DefaultBitmapSize = 45dip
		Case 50: DefaultBitmapSize = 50dip
		Case 55: DefaultBitmapSize = 55dip
		Case 60: DefaultBitmapSize = 60dip
		Case 65: DefaultBitmapSize = 65dip
		Case 70: DefaultBitmapSize = 70dip
		Case 75: DefaultBitmapSize = 75dip
		Case 80: DefaultBitmapSize = 80dip
		Case 85: DefaultBitmapSize = 85dip
		Case 90: DefaultBitmapSize = 90dip
		Case 95: DefaultBitmapSize = 95dip
		Case 100: DefaultBitmapSize = 100dip
		Case 105: DefaultBitmapSize = 105dip
		Case 110: DefaultBitmapSize = 110dip
		Case 115: DefaultBitmapSize = 115dip
		Case 120: DefaultBitmapSize = 120dip
		Case 125: DefaultBitmapSize = 125dip
		Case 130: DefaultBitmapSize = 130dip
		Case 135: DefaultBitmapSize = 135dip
		Case 140: DefaultBitmapSize = 140dip
		Case 145: DefaultBitmapSize = 145dip
		Case 150: DefaultBitmapSize = 150dip	
	End Select
End Sub
'Icon Menu Size (25 to 150) dip
Public Sub SetIconSizeMenu(Val As Int)
	Select Case Val
		
		Case 25: DefaultBitmapSizeMenu = 25dip
		Case 30: DefaultBitmapSizeMenu = 30dip
		Case 35: DefaultBitmapSizeMenu = 35dip
		Case 40: DefaultBitmapSizeMenu = 40dip
		Case 45: DefaultBitmapSizeMenu = 45dip
		Case 50: DefaultBitmapSizeMenu = 50dip
		Case 55: DefaultBitmapSizeMenu = 55dip
		Case 60: DefaultBitmapSizeMenu = 60dip
		Case 65: DefaultBitmapSizeMenu = 65dip
		Case 70: DefaultBitmapSizeMenu = 70dip
		Case 75: DefaultBitmapSizeMenu = 75dip
		Case 80: DefaultBitmapSizeMenu = 80dip
		Case 85: DefaultBitmapSizeMenu = 85dip
		Case 90: DefaultBitmapSizeMenu = 90dip
		Case 95: DefaultBitmapSizeMenu = 95dip
		Case 100: DefaultBitmapSizeMenu = 100dip
		Case 105: DefaultBitmapSizeMenu = 105dip
		Case 110: DefaultBitmapSizeMenu = 110dip
		Case 115: DefaultBitmapSizeMenu = 115dip
		Case 120: DefaultBitmapSizeMenu = 120dip
		Case 125: DefaultBitmapSizeMenu = 125dip
		Case 130: DefaultBitmapSizeMenu = 130dip
		Case 135: DefaultBitmapSizeMenu = 135dip
		Case 140: DefaultBitmapSizeMenu = 140dip
		Case 145: DefaultBitmapSizeMenu = 145dip
		Case 150: DefaultBitmapSizeMenu = 150dip	
	End Select
End Sub
'Icon Overflow Size (25 to 150) dip
Public Sub SetIconSizeOverflow(Val As Int)
	Select Case Val
		
		Case 25: DefaultOverFlowIconSize = 25dip
		Case 30: DefaultOverFlowIconSize = 30dip
		Case 35: DefaultOverFlowIconSize = 35dip
		Case 40: DefaultOverFlowIconSize = 40dip
		Case 45: DefaultOverFlowIconSize = 45dip
		Case 50: DefaultOverFlowIconSize = 50dip
		Case 55: DefaultOverFlowIconSize = 55dip
		Case 60: DefaultOverFlowIconSize = 60dip
		Case 65: DefaultOverFlowIconSize = 65dip
		Case 70: DefaultOverFlowIconSize = 70dip
		Case 75: DefaultOverFlowIconSize = 75dip
		Case 80: DefaultOverFlowIconSize = 80dip
		Case 85: DefaultOverFlowIconSize = 85dip
		Case 90: DefaultOverFlowIconSize = 90dip
		Case 95: DefaultOverFlowIconSize = 95dip
		Case 100: DefaultOverFlowIconSize = 100dip
		Case 105: DefaultOverFlowIconSize = 105dip
		Case 110: DefaultOverFlowIconSize = 110dip
		Case 115: DefaultOverFlowIconSize = 115dip
		Case 120: DefaultOverFlowIconSize = 120dip
		Case 125: DefaultOverFlowIconSize = 125dip
		Case 130: DefaultOverFlowIconSize = 130dip
		Case 135: DefaultOverFlowIconSize = 135dip
		Case 140: DefaultOverFlowIconSize = 140dip
		Case 145: DefaultOverFlowIconSize = 145dip
		Case 150: DefaultOverFlowIconSize = 150dip	
	End Select
End Sub

'Get the top item index
Public Sub TopItem As Int
	Dim Height, EachPanelHeight, x As Int
	Height = sv.ScrollPosition

	Dim p As Panel
	For i = 0 To items.Size - 1
		p = panels.Get(i)
		EachPanelHeight = EachPanelHeight + p.Height + DefaultDividerHeight
		If EachPanelHeight >= Height Then
			Return x
		End If
		x = x + 1
	Next
	
	Return -1
End Sub
'Get the bottom item index
Public Sub BottomItem As Int
	Dim Height, EachPanelHeight, x As Int
	Height = sv.ScrollPosition + sv.Height - DefaultDividerHeight

	Dim p As Panel
	For i = 0 To items.Size - 1
		p = panels.Get(i)
		EachPanelHeight = EachPanelHeight + p.Height + DefaultDividerHeight
		If EachPanelHeight >= Height Then
			If items.Get(items.Size -1) = "*Mask*" Then		'IF MASK THEN REPORT -1
				Return x -1
			Else
				Return x
			End If
		End If
		x = x + 1
	Next
	
	'items.size <> 0 is new ... test it
	If x > items.Size -1 And items.Size <> 0 Then		'THIS OCCURS WHEN YOU FAST SCROLL ALL THE WAY TO THE BOTTOM AND  HEIGHT IS SLIGHTLY HIGHER VALUE AND TOP EVENT WILL NOT RETURN ANYTHING
		If items.Get(items.Size -1) = "*Mask*" Then		'IF MASK THEN REPORT -1
			Return x -2
		Else
			Return x -1
		End If
	Else
		Return -1
	End If
End Sub

public Sub SetDividerColorMargin(blnValue As Boolean )
	blnDividerColorMargin = blnValue
	If blnValue = True Then
		'This will remove Divider Color left and right margin
		sv.Color = DefaultTextBackgroundMenuColor
		'sv.Color = Colors.ARGB(150, 255,255,255)
		Dim cnv As Canvas
		cnv.Initialize(sv)
		
		Dim Rect1 As Rect
		Rect1.Initialize(DefaultBitmapSizeMenu + 5dip, 0, sv.Width - ((DefaultBitmapSizeMenu + 5dip)/2), sv.Height)
		cnv.DrawRect(Rect1, DividerColor, True, 5dip)
	End If
End Sub
